SoToVRMLAction(3)

NAME
SoToVRMLAction - The SoToVRMLAction class builds a new scene graph using only VRML 1.0 nodes.

SYNOPSIS

#include <Inventor/actions/SoToVRMLAction.h>

Inherits SoAction.

Inherited by SoToVRML2Action.

  Public Member Functions
virtual SoType getTypeId (void) const
SoToVRMLAction (void)
virtual ~SoToVRMLAction (void)
virtual void apply (SoNode *node)
virtual void apply (SoPath *path)
virtual void apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)
SoNode * getVRMLSceneGraph (void) const
void expandSoFile (SbBool flag)
SbBool areSoFileExpanded (void) const
void setUrlName (const SbString name)
SbString getUrlName (void) const
void writeTexCoords (SbBool flag)
SbBool areTexCoordWritten (void) const
void expandTexture2Node (SbBool flag)
SbBool areTexture2NodeExpanded (void) const
void keepUnknownNodes (SbBool flag)
SbBool areUnknownNodeKept (void) const
void convertInlineNodes (SbBool flag)
SbBool doConvertInlineNodes (void) const
void conditionalConversion (SbBool flag)
SbBool doConditionalConversion (void) const
void setVerbosity (SbBool flag)
SbBool isVerbose (void) const
Public Member Functions inherited from SoAction
virtual ~SoAction (void)
virtual SbBool isOfType (SoType type) const
void apply (SoAction *beingApplied)
virtual void invalidateState (void)
AppliedCode getWhatAppliedTo (void) const
SoNode * getNodeAppliedTo (void) const
SoPath * getPathAppliedTo (void) const
const SoPathList * getPathListAppliedTo (void) const
const SoPathList * getOriginalPathListAppliedTo (void) const
SbBool isLastPathListAppliedTo (void) const
PathCode getPathCode (int &numindices, const int *&indices)
void traverse (SoNode *const node)
SbBool hasTerminated (void) const
const SoPath * getCurPath (void)
SoState * getState (void) const
PathCode getCurPathCode (void) const
virtual SoNode * getCurPathTail (void)
void usePathCode (int &numindices, const int *&indices)
void pushCurPath (const int childindex, SoNode *node=NULL)
void popCurPath (const PathCode prevpathcode)
void pushCurPath (void)
void popPushCurPath (const int childindex, SoNode *node=NULL)
void popCurPath (void)
void switchToPathTraversal (SoPath *path)
void switchToNodeTraversal (SoNode *node)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void addMethod (const SoType type, SoActionMethod method)
static void enableElement (const SoType type, const int stackindex)
static void initClass (void)
Static Public Member Functions inherited from SoAction
static void initClass (void)
static void initClasses (void)
static SoType getClassTypeId (void)
static void nullAction (SoAction *action, SoNode *node)

  Protected Member Functions
virtual const SoEnabledElementsList & getEnabledElements (void) const
virtual void beginTraversal (SoNode *node)
Protected Member Functions inherited from SoAction
SoAction (void)
virtual void endTraversal (SoNode *node)
void setTerminated (const SbBool flag)
virtual SbBool shouldCompactPathList (void) const

  Static Protected Member Functions
static SoEnabledElementsList * getClassEnabledElements (void)
static SoActionMethodList * getClassActionMethods (void)
Static Protected Member Functions inherited from SoAction
static SoEnabledElementsList * getClassEnabledElements (void)
static SoActionMethodList * getClassActionMethods (void)

  Additional Inherited Members
Public Types inherited from SoAction
enum AppliedCode { NODE = 0, PATH = 1, PATH_LIST = 2 }
enum PathCode { NO_PATH = 0, IN_PATH = 1, BELOW_PATH = 2, OFF_PATH = 3 }
Protected Attributes inherited from SoAction
SoState * state
SoActionMethodList * traversalMethods

Detailed Description

The SoToVRMLAction class builds a new scene graph using only VRML 1.0 nodes. This action is used for converting a scene graph of VRML2/VRML97 nodes to a new scene graph using only VRML1 compatible nodes.

A current limitation of this action is that nodes specific for Inventor / Coin (i.e. neither VRML1 nor VRML97 compatible nodes) are not tried to convert, they are simply ignored.

See also
    SoToVRML2Action

Since
    Coin 2.0

    TGS Inventor 2.5

Constructor & Destructor Documentation

  SoToVRMLAction::SoToVRMLAction (void )
Constructor.

  SoToVRMLAction::~SoToVRMLAction (void ) [virtual]
The destructor.

Member Function Documentation

  SoType SoToVRMLAction::getTypeId (void ) const [virtual]
Returns the type identification of an object derived from a class inheriting SoAction. This is used for runtime type checking and "downward" casting.

Implements SoAction.

Reimplemented in SoToVRML2Action.

  SoType SoToVRMLAction::getClassTypeId (void ) [static]
This static method returns the SoType object associated with objects of this class.

  void SoToVRMLAction::addMethod (const SoType type, SoActionMethod method) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoToVRMLAction::enableElement (const SoType type, const int stackindex) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  const SoEnabledElementsList & SoToVRMLAction::getEnabledElements (void ) const [protected], [virtual]
Returns list of enabled elements.

Reimplemented from SoAction.

Reimplemented in SoToVRML2Action.

  SoEnabledElementsList * SoToVRMLAction::getClassEnabledElements (void ) [static], [protected]
Returns list of enabled elements for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  SoActionMethodList * SoToVRMLAction::getClassActionMethods (void ) [static], [protected]
Returns list of action methods for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  void SoToVRMLAction::initClass (void ) [static]
Initializes the runtime type system for this class, and sets up the enabled elements and action method list.

  void SoToVRMLAction::apply (SoNode * root) [virtual]
Applies the action to the scene graph rooted at root.

Note that you should not apply an action to a node with a zero reference count. The behavior in that case is undefined.

Reimplemented from SoAction.

Reimplemented in SoToVRML2Action.

  void SoToVRMLAction::apply (SoPath * path) [virtual]
Applies the action to the parts of the graph defined by path.

Note that an SoPath will also contain all nodes that may influence e.g. geometry nodes in the path. So for instance applying an SoGLRenderAction on an SoPath will render that path as expected in the view, where geometry will get its materials, textures, and other appearance settings correctly.

If the path ends in an SoGroup node, the action will also traverse the tail node's children.

Reimplemented from SoAction.

Reimplemented in SoToVRML2Action.

  void SoToVRMLAction::apply (const SoPathList & pathlist, SbBool obeysrules = FALSE) [virtual]
Applies action to the graphs defined by pathlist. If obeysrules is set to TRUE, pathlist must obey the following four conditions (which is the case for path lists returned from search actions for non-group nodes and path lists returned from picking actions):

All paths must start at the same head node. All paths must be sorted in traversal order. The paths must be unique. No path can continue through the end point of another path.

See also
    SoAction::apply(SoPath * path)

Reimplemented from SoAction.

Reimplemented in SoToVRML2Action.

  SoNode * SoToVRMLAction::getVRMLSceneGraph (void ) const
Returns the VRML scene graph.

  void SoToVRMLAction::expandSoFile (SbBool flag)
Sets whether SoFile nodes are expanded (i.e. their contents is copied) in the new scene graph or not.

  SbBool SoToVRMLAction::areSoFileExpanded (void ) const
Returns whether SoFile nodes are expanded (i.e. their contents is copied) in the new scene graph or not.

  void SoToVRMLAction::setUrlName (const SbString name)
Sets the URL (directory) where VRML inline nodes are written to.

  SbString SoToVRMLAction::getUrlName (void ) const
Returns the URL (directory) where VRML inline nodes are written to.

  void SoToVRMLAction::writeTexCoords (SbBool flag)
Sets whether texture coordinates are written to the new scene graph or not.

  SbBool SoToVRMLAction::areTexCoordWritten (void ) const
Returns whether texture coordinates are written to the new scene graph or not.

  void SoToVRMLAction::expandTexture2Node (SbBool flag)
Sets whether texture files are expanded (i.e. their contents is copied) in the new scene graph or not.

  SbBool SoToVRMLAction::areTexture2NodeExpanded (void ) const
Returns whether texture files are expanded (i.e. their contents is copied) in the new scene graph or not.

  void SoToVRMLAction::keepUnknownNodes (SbBool flag)
Sets whether unknown nodes are preserved in the new scene graph or not.

  SbBool SoToVRMLAction::areUnknownNodeKept (void ) const
Returns whether unknown nodes are preserved in the new scene graph or not.

  void SoToVRMLAction::convertInlineNodes (SbBool flag)
Sets whether inline nodes are converted to VRML in the new scene graph or not.

  SbBool SoToVRMLAction::doConvertInlineNodes (void ) const
Returns whether inline nodes are converted to VRML in the new scene graph or not.

  void SoToVRMLAction::conditionalConversion (SbBool flag)
Sets whether inline nodes are conditionally converted to VRML in the new scene graph or not.

  SbBool SoToVRMLAction::doConditionalConversion (void ) const
Returns whether inline nodes are conditionally converted to VRML in the new scene graph or not.

  void SoToVRMLAction::setVerbosity (SbBool flag)
Sets whether additional information should be written to output during the conversion process.

  SbBool SoToVRMLAction::isVerbose (void ) const
Returns whether additional information should be written to output during the conversion process.

  void SoToVRMLAction::beginTraversal (SoNode * node) [protected], [virtual]
This virtual method is called from SoAction::apply(), and is the entry point for the actual scene graph traversal.

It can be overridden to initialize the action at traversal start, for specific initializations in the action subclasses inheriting SoAction.

Default method just calls traverse(), which any overridden implementation of the method must do too (or call SoAction::beginTraversal()) to trigger the scene graph traversal.

Reimplemented from SoAction.

Reimplemented in SoToVRML2Action.

Author

Generated automatically by Doxygen for Coin from the source code.